"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _jest = require("jest");

/* eslint-disable class-methods-use-this */
var GoPatoDynamoDBJestPlugin =
/*#__PURE__*/
function () {
  function GoPatoDynamoDBJestPlugin(serverless, options) {
    var _this = this;

    this.serverless = serverless;
    this.options = options;
    this.commands = {
      'dynamodb-jest': {
        usage: 'Run unit tests',
        lifecycleEvents: ['testHandler']
      }
    };
    this.hooks = {
      'before:dynamodb-jest:testHandler': function beforeDynamodbJestTestHandler() {
        return _this.serverless.pluginManager.run(['dynamodb-local', 'start']);
      },
      'dynamodb-jest:testHandler': this.testHandler.bind(this),
      'after:dynamodb-jest:testHandler': function afterDynamodbJestTestHandler() {
        return _this.serverless.pluginManager.run(['dynamodb-local', 'stop']);
      }
    };
  }

  var _proto = GoPatoDynamoDBJestPlugin.prototype;

  _proto.testHandler = function testHandler() {
    Object.assign(process.env, (0, _extends2.default)({}, this.serverless.service.provider.environment, {
      NODE_ENV: 'test',
      IS_OFFLINE: 'true'
    }));
    return (0, _jest.runCLI)(this.options, [this.serverless.config.servicePath]);
  };

  return GoPatoDynamoDBJestPlugin;
}();

exports.default = GoPatoDynamoDBJestPlugin;
module.exports = exports.default;